#define _STR(x)      #x
#define _STR2(x)     _STR(x)
#define __SLINE__    _STR2(__LINE__)
#define HERE         __FILE__  ":" __SLINE__ " "

#define MAX_HBC_NODES                64

#define DTSD_FIFO_IN           "/tmp/dtsd.in"
#define DTSD_FIFO_RES          "/tmp/dtsd.res"
#define DTSD_PID_FILE          "/var/run/dtsd.pid"
#define WORK_BUF_SIZE         4092 * 16

#define MAX_MSG_SIZE           4092 * 8
#define MAX_CMD_RES_SIZE       4092 * 7
#define MAX_CMD_ERR_SIZE       4092 * 1

// tokens for result.
#define TOKEN_RESULT                 ">"
#define TOKEN_HOST               "HOST-"
#define TOKEN_STAT             "RESULT-"
#define TOKEN_ERR                 "ERR-"
#define TOKEN_MSG                 "MSG-"
#define TOKEN_OK                    "OK"
#define TOKEN_NG                    "NG"

// tokens for result's msg.
#define TOKEN_QUESTION               "?"
#define TOKEN_EQUAL                  "="
#define TOKEN_SRV_ADDR        "srv_addr"
#define TOKEN_SRV_PORT        "srv_port"
#define TOKEN_IFACE              "iface"
#define TOKEN_MACADDR           "hwaddr"
#define TOKEN_NETMASK          "netmask"
#define TOKEN_FAKEMAC          "fakemac"
#define TOKEN_RI                    "ri"
#define TOKEN_RI_OPT            "ri_opt"
#define TOKEN_NODES               "node"
#define TOKEN_PROXY_PORT    "proxy_port"

// tokens for node info.
#define TOKEN_UNDEFINED       "undefined"
#define TOKEN_SHARP                  "#"
#define TOKEN_SLASH                  "/"
#define TOKEN_PERCENT                "%"
#define TOKEN_COLON                  ":"
#define TOKEN_DEAD              "(dead)"

/* max string length of each option. */
#define MAX_LEN_HOST_SRV             100
#define MAX_LEN_SRV_ADDR              20
#define MAX_LEN_SRV_PORT              10
#define MAX_LEN_IFACE                 20
#define MAX_LEN_NETMASK               20
#define MAX_LEN_MACADDR               25
#define MAX_LEN_FAKEMAC               10
#define MAX_LEN_RI                    20
#define MAX_LEN_RI_OPT              4092
#define MAX_LEN_NODES           4092 * 5
#define MAX_LEN_CHASH                 20
#define MAX_LEN_DEAD_NODE             20
#define MAX_LEN_PROXY_PORT            20
#define MAX_LEN_VNODE_ID              20
#define MAX_LEN_VNODE_HASH_ID         50

/* max string length of all option. */
#define MAX_OPT_LEN         (MAX_LEN_HOST_SRV + MAX_LEN_IFACE +  MAX_LEN_NETMASK\
				+ MAX_LEN_MACADDR + MAX_LEN_FAKEMAC + MAX_LEN_RI\
				+ MAX_LEN_RI_OPT + MAX_LEN_NODES +\
				+ MAX_LEN_CHASH + MAX_LEN_DEAD_NODE)

/* max string length of result msg. */
#define MAX_LEN_HOST      MAX_LEN_SRV_ADDR
#define MAX_LEN_STAT                    10
#define MAX_LEN_ERR       MAX_CMD_ERR_SIZE
#define MAX_LEN_RES       MAX_CMD_RES_SIZE

// max length of returned server confs.
#define MAX_LEN_RETURNED_SRV_CONFS     4092 * 7
#define MAX_LEN_RETURNED_NODES  4092 * 6 + 2048

/* max value of each option. */
#define MAX_VAL_FAKEMAC                1
#define MAX_VAL_CHASH                  1
#define MAX_VAL_DEAD_NODE              1
#define MAX_VAL_PROXY_PORT         65535
#define MIN_VAL_FAKEMAC                0
#define MIN_VAL_CHASH                  0
#define MIN_VAL_DEAD_NODE              0
#define MIN_VAL_PROXY_PORT         45192

/* max array length of option vector. */
#define MAX_LEN_OPTV                 512
/* max string length of option vector's each value. */
#define MAX_LEN_OPTV_VAL            4096

#ifdef DEBUG
# define dstatic
#else
# define dstatic static
#endif
