#ifndef _DTSADMIN_H
#define _DTSADMIN_H

#include "dtsd_optparser.h"

#define SETTING_HEADER_HASH  "INTERnetAddress:Port RequestInspector Proxyport\n\
  -> HeartbeatHostName [VirtualNodeID HashValue]"
#define SETTING_HEADER_NOHASH             "INTERnetAddress:Port RequestInspector Proxyport\n\
  -> HeartbeatHostName [VirtualNodeID]"
#define SETTING_HEADER_VERBOSE_HASH  "INTERnetAddress:Port Interface Netmask Fakemac Macaddr RequestInspector RequestInspectorOpt Proxyport\n\
  -> HeartbeatHostName [VirtualNodeID HashValue]"
#define SETTING_HEADER_VERBOSE_NOHASH  "INTERnetAddress:Port Interface Netmask Fakemac Macaddr RequestInspector RequestInspectorOpt Proxyport\n\
  -> HeartbeatHostName [VirtualNodeID]"

#define MAX_LINE_BUFSIZ                      8192
#define MAX_TRY_BIND_PROXY                     10
// use for -R.
#define MAX_LEN_CMD_STRV                      512
// max command length for -R.
#define MAX_LEN_CMD_STRV_VAL                 8192
// use for -L and -S.
#define MAX_LEN_LIST_STRV                    8192
#define MAX_LEN_LIST_STRV_VAL                4096

#define DTSADMIN_PID_FILE "/var/run/dtsadmin.pid"

#define MODULE_PREFIX                  "dtsadmin"

/* communication method between dtsadmin and dtsd. */
struct com_method {
	/* initialize. */
	int (*init)(const char *, int);
	/* send the str to dtsd. */
	int (*send_request) (const struct options *);
	/* receive result and set to str. */
	int (*receive_result) (char ** res[], int *);
	/* finalize. */
	int (*fin) (const char *, int);
};

#endif
