#ifndef _DTSADMIN_NODEINFO_HANDLER_H
#define _DTSADMIN_NODEINFO_HANDLER_H

#include "common.h"
#include "dtsd_common.h"

struct node_info {
	char hb_node_name[MAX_LEN_HOST];
	char addr[MAX_LEN_SRV_ADDR];
	char id[MAX_LEN_VNODE_ID];
	char id_hash[MAX_LEN_VNODE_HASH_ID];

	TAILQ_ENTRY(node_info) entry;
};

struct node_info_vidset {
	char hb_node_name[MAX_LEN_HOST];
	char addr[MAX_LEN_SRV_ADDR];
	vnode_idset idset;

	TAILQ_ENTRY(node_info_vidset) entry;
};

TAILQ_HEAD(node_info_head, node_info);
TAILQ_HEAD(node_info_vidset_head, node_info_vidset);

/* expect following format.                         */
/* dts01%10.0.0.1/1#00000001:dts02%10.0.0.2/#00000002,.... */
extern int str2ninfoq(const char * str, struct node_info_head * ni_head);
extern int free_ninfoq(struct node_info_head * ni_head);
extern void print_ninfoq(const struct node_info_head * ni_head);

extern int ninfoq2ninfo_vidsetq(struct node_info_head * ni_head,
				struct node_info_vidset_head * niv_head);
extern int free_ninfo_vidsetq(struct node_info_vidset_head * niv_head);

#endif
