#ifndef _DTSADMIN_SERVER_CONF_HANDLER_H
#define _DTSADMIN_SERVER_CONF_HANDLER_H

#include <sys/queue.h>

#include "common.h"

TAILQ_HEAD(server_confs_head, server_confs);

struct server_confs {
	char srv_addr[MAX_LEN_HOST_SRV];
	char srv_port[MAX_LEN_HOST_SRV];
	char iface[MAX_LEN_IFACE];
	char macaddr[MAX_LEN_MACADDR];
	char netmask[MAX_LEN_MACADDR];
	char fakemac[MAX_LEN_FAKEMAC];
	char ri[MAX_LEN_RI];
	char ri_opt[MAX_LEN_RI_OPT];
	char proxy_port[MAX_LEN_PROXY_PORT];
	char nodes[MAX_LEN_RETURNED_NODES];

	TAILQ_ENTRY(server_confs) entry;
};

extern int str2sconfq(const char * msg, struct server_confs_head * shead);
extern int free_sconfq(struct server_confs_head * shead);
extern void print_sconfq(struct server_confs_head * shead);

#endif

