#ifndef _DTSD_COMMON_H
#define _DTSD_COMMON_H

#include <stdint.h>

#ifndef DEBUG
#undef HERE
#define HERE "dtsd:"
#endif

// TODO be configurable
#define DTSCTL_PATH "/usr/bin/"
#define FAKEMAC_PATH "/proc/sys/net/fakemac/"
#define IFCONFIG_PATH "/sbin/"
#define ECHO_PATH "/bin/"
#define DTS_CONFIG_PATH "/proc/net/dts/configs/"

struct dtsd_config {
	char * progname;
	char * hostname;
	int help_flag;
	int debug_flag;
	int force_flag;
	int daemonize_flag;
	int ready_flag;
	int last_proxy_port;
	char * interface;
	char * ipaddr;
	uint32_t naddr;
	struct server_conf * server_conf;
	struct hbc_node * mynode;
};

typedef uint64_t vnode_idset;

// TODO FIX, include from ftcs
#define VNODE_ID_MAX 63

#define append_IDset(id, IDset) \
        ((IDset) |= 1ull << (id))

#define contain_IDset(id, IDset) \
        ((id >= 0 && id <= VNODE_ID_MAX) && \
         (((IDset) & 1ull << (id)) != 0))

#define for_each_idset(id, IDset) \
        for(id = 0; id <= VNODE_ID_MAX; id++) \
                if (((IDset) & (1ull << id)) > 0)

#define monus_IDset(lIDset, rIDset) \
        (lIDset - ((lIDset) & (rIDset)))

#define add_IDset(lIDset, rIDset) \
        ((lIDset) | (rIDset))

extern int serialize_idset(vnode_idset idset, char * str);
extern int deserialize_idset(char * str, vnode_idset * idset);
extern int resolve_host(const char * hostname, uint32_t * addr);
extern int parse_idset(char * str, vnode_idset * IDset);
extern int parse_hostsrv(const char * hostsrv, uint32_t * addr, int * port);
extern int parse_nodespec(char * node, char **hb_node_name, vnode_idset * idset);

#endif
