#include <stdint.h>
#include <sys/types.h>

#if DEBUG
#define DTS_PLUGIN_DIR "./ri"
#else
#define DTS_PLUGIN_DIR "/var/lib/dtsd/ri"
#endif

struct ri {
    int sock;
    int optargc;
    char ** optargv;
    struct server_conf * conf;
    void * uniq_param;
};

// Request Inspector Interface
struct ri_intf {
    const char const * name;
    struct ri * (* initialize) (int sock, uint32_t addr, uint16_t port, char * optarg);
    int (* run) (struct ri *);
    int (* stop) (struct ri *);
    int (* add_node) (struct ri *, uint32_t ipaddr);
    int (* remove_node) (struct ri *, uint32_t ipaddr);
    int (* finalize) (struct ri *);
    const char const* (* usage) ();
};

extern struct ri_intf * create_ri_intf(void);
typedef struct ri_intf * (* dts_dll_init_function)(void);
