#ifndef _DTSD_SERVER_CONF_H
#define _DTSD_SERVER_CONF_H

struct dtsd_node_info {
	struct dtsd_node_info * next;
	struct server_conf * srv_conf;
	char * hb_node_name;
	struct hbc_node * hbc_node;
	vnode_idset idset;
};

#define for_each_node_info(i, conf) \
	if (conf != NULL && conf->ni != NULL) \
		for (i = conf->ni; i != NULL; i = i->next) \
			if (i != NULL)

struct server_conf {
	struct server_conf * next;
	uint32_t server_address;
	uint32_t netmask;
	int server_port;
	char * iface;
	char * hwaddr;
	int fakemac;
	char * riname;
	struct ri * ri;
	struct ri_intf * ri_intf;
	char * ri_opt;
	struct dtsd_node_info * ni;
	int proxy_port;
	int proxy_sock;
};

#define for_each_server_conf(i, conf) \
	if (conf != NULL)\
		for (i = conf; i != NULL; i = i->next)\
			if (i != NULL)

extern int ServerConf2str(const struct server_conf * conf, char * str, int maxlen);
extern int str2ServerConf(const char * str, struct server_conf ** conf);
extern int apply_ServerConf(struct dtsd_config *, const struct server_conf *);
extern int append_NodeConf(struct server_conf * conf, struct dtsd_node_info * info);
extern int append_ServerConfList(struct server_conf * list, struct server_conf * conf);
extern int append_OptionsAsServerConf(struct server_conf ** conf, struct options * opt);
extern int NodeInfo2opt(const struct dtsd_node_info * info, struct options * opt);
extern int opt2NodeInfo(struct options * opt, struct dtsd_node_info * info);
extern int serialize_NodeInfo(const struct dtsd_node_info * info, char * str);
extern int deserialize_NodeInfo(char * str, struct dtsd_node_info * info);
extern int free_node_info(struct dtsd_node_info * info);
extern int free_node_info_list(struct dtsd_node_info * info);
extern int ServerConf2opt(const struct server_conf * conf, struct options * opt);
extern int opt2ServerConf(struct options * opt, struct server_conf * conf);
extern int free_server_conf(struct server_conf * conf);
extern int free_server_conf_list(struct server_conf * info);
extern int serialize_server_conf(const struct server_conf * conf, char * str);
extern int deserialize_server_conf(char * str, struct server_conf * conf);
extern int count_opt(const struct server_conf * server_conf);
extern int add_ServerConf(struct dtsd_config *, struct server_conf *);
extern struct server_conf * find_ServerConf(const struct dtsd_config *,
											const char *);
extern int add_NodeInfo(struct server_conf *, struct dtsd_node_info *);
extern int remove_NodeInfo(struct server_conf *, const char *);

#endif
