#include <stdio.h>
#include <stdarg.h>
#include <stdbool.h>

#include "dtsd_util.h"

int debug_flag = 0;

int
debug_printf(const char *format, ...)
{
	int rv = 0;
	va_list ap;

	if (debug_flag) {
		va_start(ap, format);
		rv = vprintf(format, ap);
		va_end(ap);
	}
	return rv;
}

int
debug_fprintf(FILE *stream, const char *format, ...)
{
	int rv = 0;
	va_list ap;

	if (debug_flag) {
		va_start(ap, format);
		rv = vfprintf(stream, format, ap);
		va_end(ap);
	}
	return rv;
}


int
eprintf(const char *format, ...)
{
	int rv = 0;
	va_list ap;

	va_start(ap, format);
	rv = vfprintf(stderr, format, ap);
	va_end(ap);
	return rv;
}
