#ifndef NEIGHSETV4_H
#define NEIGHSETV4_H

#include <linux/rbtree.h>

typedef uint64_t nsv4_bitset_t;

#define NSV4_SUFFIX_MASK 0x3fU
#define NSV4_PREFIX_MASK (~NSV4_SUFFIX_MASK)

struct nsv4_node {
	struct rb_node rbnode;
	uint32_t prefix;
	nsv4_bitset_t bitset;
};

struct neighsetv4 {
	struct rb_root rbroot;
	unsigned nr_set;
};

struct nsv4_iter {
	struct rb_node *rbnode;
	int index;
};

/* public APIs */
int nsv4_add(struct neighsetv4 *s, __be32 addr);
int nsv4_member(const struct neighsetv4 *s, __be32 addr);
int nsv4_size(const struct neighsetv4 *s);
void nsv4_clear(struct neighsetv4 *s);
void nsv4_init(struct neighsetv4 *s);
void nsv4_destroy(struct neighsetv4 *s);
int nsv4_setup(void);
void nsv4_cleanup(void);

int nsv4_first(const struct neighsetv4 *s, struct nsv4_iter *iter);
int nsv4_next(struct nsv4_iter *iter);
__be32 nsv4_iter_address(const struct nsv4_iter *iter);

#endif /* #ifndef NEIGHSETV4_H */
