#!/usr/bin/python

import _ftcs

def request_handover(sock, target_host, target_port, buf, offset):
    """call ftcs_request_handover()
Arguments:
  sock        -- socket object returned by socket.socket()
  target_host -- handover target's host (String)
  target_port -- handover target's port (Integer)
  buf         -- already read contents
  offset      -- request offset
"""
    fileno = sock.fileno()
    if fileno <= 0:
        raise RuntimeError, "sock.fileno() returns 0 or negative"
    if target_port <=0 or target_port > 65535:
        raise RuntimeError, "target_port must be 1~65535"
    rv = _ftcs.request_handover(fileno, target_host, target_port, buf, offset)
    if rv < 0:
        raise RuntimeError, "handover failed"
    return rv
