#!/bin/bash

BINDIR=/usr/bin
ETCDIR=/etc/dts
DATADIR=/var/dts
ROOTCRONTAB=/var/spool/cron/crontabs/root
CUID=`id | sed 's/uid=\([0-9]\+\)(.\+/\1/'`

if [ $CUID -ne 0 ]
then
    echo "only root user" >&2
    exit 1
fi

mkdir -p $ETCDIR $DATADIR
cp ./bin/dts_mm ./bin/dts_monitor $BINDIR
cp ./etc/dts/dts_monitor.conf ./etc/dts/dts_mm.conf $ETCDIR
chmod +x $BINDIR/dts_mm $BINDIR/dts_monitor
chmod -R +r $ETCDIR
echo "* * * * * $BINDIR/dts_mm" >> $ROOTCRONTAB
chown root:crontab  $ROOTCRONTAB
chmod 600 $ROOTCRONTAB

/etc/init.d/cron restart

pushd ./man
make man
make man-install
popd

echo "setup: succeeded"

